'Program sterownika kolumn-modu sterujcy  - 2013-12-30 Versja 1.0
$version 1 , 0 , 6
Config Submode = New
Rem deklaracje parametrw dla calego programu
$regfile = "M8def.dat"
$crystal = 8000000                                          '8 MHz
$baud = 9600

$eeprom
Data 0
Data &H12
Dim Stan_polaczen_eeprom As Eram Byte At 1 Overlay

$data

$hwstack = 100
$swstack = 100
$framesize = 100

Dim Wieza1 As Byte                                          'przypisanie pokoju do wiey
Dim Wieza2 As Byte
Dim Wieza1_tmp As Byte                                      'przypisanie pokoju do wiey
Dim Wieza2_tmp As Byte
Dim Stan_polaczen As Byte
Dim Stan_polaczen_tmp As Byte

Const Rozkaz_przeslij_stan_polaczen = &HAA
Const Blad = &HA8

'Rozkaz moe by rwny albo "Przeslij_stan_polaczen" albo
'podaje Jak Wiee Maj By Poczone - Zawarto byte'u informacji - 11112222
'1111 - warto od 1 do 5 przyczenie wiey 1 do pokoju 1 - 5
'2222 - warto od 1 do 5 przyczenie wiey 2 do pokoju 1 - 5
'Rozkaz przeczenia wie moe mie warto od &H12 do &H54

Wieza_1_rezystor Alias Portc.5
Wieza_2_rezystor Alias Portb.5
Wieza_1_port Alias Portc
Wieza_2_port Alias Portb
Zasilanie Alias Portd.4                                     'Sterowanie zasilaniem moduu sterujcego i przekanikw
Dioda_czerwona Alias Portd.7

Const Yes = 1
Const No = 0

'Poniej podane wartoci w msek
Const Op_po_wlaczeniu_zasilania = 100                       'Opnienie po wczeniu zasilania
Const Op_po_wlaczeniu_rezystora = 50                        'Opnienie po wczeniu rezystora obciajcego
Const Op_po_przelaczeniu_kolumn = 50                        'Opnienie po przeczeniu kolumn

Dim B As Byte , Rozkaz As Byte

Macro Przelacz_wieze_1
Wieza1 = Wieza1_tmp
Set Wieza_1_rezystor                                        'Zaaczenie rezystora wiey 1
Waitms Op_po_wlaczeniu_rezystora                            'Opnienie
Reset Watchdog
Wieza_1_port = Wieza_1_port And &B11100000                  'Wyczenie wiey 1
Waitms Op_po_przelaczeniu_kolumn                            'Opnienie
Reset Watchdog
B = 1
While Wieza1_tmp > 1
   Rotate B , Left
   Decr Wieza1_tmp
Wend
B = B Or &B00100000                                         'Dodanie wczenia rezystora podcigajcego
Wieza_1_port = Wieza_1_port Or B                            'Zaczenie wiey 1
Waitms Op_po_przelaczeniu_kolumn                            'Opnienie
Reset Wieza_1_rezystor                                      'Odczenie rezystora wiey 1
Reset Watchdog
End Macro

Macro Przelacz_wieze_2
Wieza2 = Wieza2_tmp
Set Wieza_2_rezystor                                        'Zaaczenie rezystora wiey 2
Waitms Op_po_wlaczeniu_rezystora                            'Opnienie
Reset Watchdog                                              'Wyczenie wiey 2
Wieza_2_port = Wieza_2_port And &B11100000
Waitms Op_po_przelaczeniu_kolumn                            'Opnienie
Reset Watchdog
B = 1
While Wieza2_tmp > 1
   Rotate B , Left
   Decr Wieza2_tmp
Wend
B = B Or &B00100000                                         'Dodanie wczenia rezystora podcigajcego
Wieza_2_port = Wieza_2_port Or B                            'Zaczenie wiey 2
Waitms Op_po_przelaczeniu_kolumn                            'Opnienie
Reset Wieza_2_rezystor                                      'Odczenie rezystora wiey 2
Reset Watchdog
End Macro

Macro Przelacz_wieze
If Wieza1 <> Wieza1_tmp Or Wieza2 <> Wieza2_tmp Then
   If Wieza1 = Wieza1_tmp Then
      Przelacz_wieze_2
   Elseif Wieza2 = Wieza2_tmp Then
      Przelacz_wieze_1
   Else
      Wieza1 = Wieza1_tmp : Wieza2 = Wieza2_tmp
      Set Wieza_1_rezystor                                  'Zaaczenie rezystora wiey 1
      Waitms Op_po_wlaczeniu_rezystora                      'Opnienie
      Reset Watchdog
      Wieza_1_port = Wieza_1_port And &B11100000            'Wyczenie wiey 1
      Set Wieza_2_rezystor                                  'Zaaczenie rezystora wiey 2
      Waitms Op_po_wlaczeniu_rezystora
      Reset Watchdog                                        'Opnienie
      Wieza_2_port = Wieza_2_port And &B11100000            'Wyczenie wiey 2
      Waitms Op_po_przelaczeniu_kolumn                      'Opnienie
      Reset Watchdog
      B = 1
      While Wieza1_tmp > 1
         Rotate B , Left
         Decr Wieza1_tmp
      Wend
      B = B Or &B00100000                                   'Dodanie wczenia rezystora podcigajcego
      Wieza_1_port = Wieza_1_port Or B                      'Zaczenie wiey 1
      Waitms Op_po_przelaczeniu_kolumn                      'Opnienie
      Reset Wieza_1_rezystor                                'Odczenie rezystora 1
      Reset Watchdog
      B = 1
      While Wieza2_tmp > 1
         Rotate B , Left
         Decr Wieza2_tmp
      Wend
      B = B Or &B00100000                                   'Dodanie wczenia rezystora podcigajcego
      Wieza_2_port = Wieza_2_port Or B                      'Zaczenie wiey 2
      Waitms Op_po_przelaczeniu_kolumn                      'Opnienie
      Reset Wieza_2_rezystor
      Reset Watchdog                                        'Odczenie rezystora 2
   End If
End If
End Macro


Function Poprawny_stan_polaczen(byval Stan As Byte) As Byte
Wieza2_tmp = Stan And &B00001111
Wieza1_tmp = Stan And &B11110000
Shift Wieza1_tmp , Right , 4
If Wieza1_tmp = 0 Or Wieza1_tmp > 5 Or Wieza2_tmp = 0 Or Wieza2_tmp > 5 Or Wieza1_tmp = Wieza2_tmp Then
   Poprawny_stan_polaczen = 0
Else
   Stan_polaczen = Stan
   Poprawny_stan_polaczen = 1
End If
End Function

On Int0 Wylaczono_zasilanie
Dim B_tmp As Byte

My_begin:
$initmicro
Waitms Op_po_wlaczeniu_zasilania
Reset Watchdog
Set Zasilanie
If Poprawny_stan_polaczen(stan_polaczen_eeprom) = 0 Then
   Set Dioda_czerwona
   Stan_polaczen_eeprom = &H12
   Waitms 10
   B_tmp = Poprawny_stan_polaczen(stan_polaczen_eeprom)
End If
Przelacz_wieze
Do
   Rozkaz = Inkey()
   If Rozkaz > 0 Then
      If Rozkaz = Rozkaz_przeslij_stan_polaczen Then
         Printbin Stan_polaczen
         Reset Dioda_czerwona
      Else
         If Poprawny_stan_polaczen(rozkaz) = 1 Then
            Reset Dioda_czerwona
            Printbin Stan_polaczen
            Przelacz_wieze
         Else
            Set Dioda_czerwona
            Rozkaz = Blad
            Printbin Rozkaz
         End If
      End If
   End If
   Reset Watchdog
   Loop
End

_init_micro:
Config Wieza_1_port = Output                                'Sterowanie przekanikami
Config Wieza_2_port = Output                                'Sterowanie przekanikami
Wieza_1_port = 0
Wieza_2_port = 0
Config Pind.4 = Output                                      'Sterowanie zasilaniem moduu sterujcego i przekanikw
Config Pind.5 = Input                                       'Sterowanie rozadowaniem kondensatora
Config Pind.7 = Output                                      'Dioda czerwona
Reset Dioda_czerwona
Config Pind.3 = Output                                      'Sterowania kierunkiem transmisji 485
Config Print0 = Portd.3 , Mode = Set                        'Ustawienie pinu sterowania kierunkiem transmisji 485
Config Int0 = Rising
Enable Interrupts
Enable Int0
Config Watchdog = 128
Start Watchdog
Return

Wylaczono_zasilanie:
Config Pind.5 = Output                                      'Sterowanie rozadowaniem kondensatora
Reset Portd.5
Reset Zasilanie                                             ' Wycz zasilanie moduu sterujcego i przekanikw
Reset Dioda_czerwona
Stan_polaczen_eeprom = Stan_polaczen
Stop Watchdog
Waitms 10
Set Dioda_czerwona
Wait 1
Set Zasilanie                                               ' Jei zasilanie powrcio to wcz ponownie zasilanie moduu sterujcego
Start Watchdog
Return